Subject: Re: How to (easily) install multiple versions of the same package (from a repository)?
From: Brian Dessent <[email-masked]>
To: "[email-masked]'" <[email-masked]>
Date: Thu, 27 Jan 2005 16:03:21 -0800

Adam Heinz wrote:

> When you ask the Cygwin setup program to install a different version of an
> installed package, it uninstalls the installed version, so our current
> installation process will not support multiple versions.
> 
> I'm looking into automated install options, but haven't found any silver
> bullets yet.
> http://www.cygwin.com/ml/cygwin/2004-07/msg01061.html

The easiest way would be to just make your own packages.  If you want
Foo v1.1 and Foo v2.1 then make "foo1-1.1" and "foo2-2.1" and just
install them both.  For example look at how ncurses, readline, db, and
similar packages are currently offered.  You will have to ensure that
the file layouts of the two packages do not collide, because that will
confuse setup.  Do any symlinking that might share common files in a
postinstall/preremove.

> I'd really like to end up with a Unix-style environment, i.e. using symlinks
> to point python to python_2_4_0.exe and python_2_3 to python_2_3_4.exe.  I'd
> like to do this in such a way that the setup burden is entirely on my
> shoulders and that everyone else has an extremely trivial setup process.

I think you'll find that symlinking to executables may not be what you
want.  It's fine if you only plan to call the command from Cygwin but
win32 will not understand the symlink (if I remember correctly) and so
those commands won't exist outside of Cygwin.  I think setup.exe handles
this by making all links in the packages as hard links (which
essentially ends up making a copy of the file.)

Brian

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/